std::allocator_traits< _Alloc > Struct Template Reference
Utilities » Memory » Allocators

`#include <memory>`

Inheritance diagram for std::allocator_traits< _Alloc >:
[legend]

## Public Types

typedef _Alloc | allocator_type
using | const_pointer
using | const_void_pointer
using | difference_type
using | is_always_equal
using | pointer
using | propagate_on_container_copy_assignment
using | propagate_on_container_move_assignment
using | propagate_on_container_swap
template<typename _Tp>
using | rebind_alloc
template<typename _Tp>
using | rebind_traits
using | size_type
typedef _Alloc::value_type | value_type
using | void_pointer

## Static Public Member Functions

static constexpr pointer | allocate (_Alloc &__a, size_type __n)
static constexpr pointer | allocate (_Alloc &__a, size_type __n, const_void_pointer __hint)
template<typename _Tp, typename... _Args>
static constexpr __enable_if_t< __can_construct< _Alloc, _Tp, _Args... > > | construct (_Alloc &__a, _Tp *__p, _Args &&... __args) noexcept(_S_nothrow_construct< _Tp, _Args... >())
static constexpr void | deallocate (_Alloc &__a, pointer __p, size_type __n)
template<typename _Tp>
static constexpr void | destroy (_Alloc &__a, _Tp *__p) noexcept(noexcept(_S_destroy(__a, __p, 0)))
static constexpr size_type | max_size (const _Alloc &__a) noexcept
static constexpr _Alloc | select_on_container_copy_construction (const _Alloc &__rhs)

## Detailed Description

template<typename _Alloc>
struct std::allocator_traits< _Alloc >

Uniform interface to all allocator types.

Since
  C++11

Definition at line 144 of file bits/alloc_traits.h.

## Member Typedef Documentation

## allocator_type

template<typename _Alloc>

typedef _Alloc std::allocator_traits< _Alloc >::allocator_type

The allocator type.

Definition at line 147 of file bits/alloc_traits.h.

## const_pointer

template<typename _Alloc>

using std::allocator_traits< _Alloc >::const_pointer

The allocator's const pointer type.

`Alloc::const_pointer` if that type exists, otherwise pointer_traits<pointer>::rebind<const value_type>

Definition at line 196 of file bits/alloc_traits.h.

## const_void_pointer

template<typename _Alloc>

using std::allocator_traits< _Alloc >::const_void_pointer

The allocator's const void pointer type.

`Alloc::const_void_pointer` if that type exists, otherwise pointer_traits<pointer>::rebind<const void>

Definition at line 212 of file bits/alloc_traits.h.

## difference_type

template<typename _Alloc>

using std::allocator_traits< _Alloc >::difference_type

The allocator's difference type.

`Alloc::difference_type` if that type exists, otherwise pointer_traits<pointer>::difference_type

Definition at line 220 of file bits/alloc_traits.h.

## is_always_equal

template<typename _Alloc>

using std::allocator_traits< _Alloc >::is_always_equal

Whether all instances of the allocator type compare equal.

`Alloc::is_always_equal` if that type exists, otherwise `is_empty<Alloc>::type`

Definition at line 260 of file bits/alloc_traits.h.

## pointer

template<typename _Alloc>

using std::allocator_traits< _Alloc >::pointer

The allocator's pointer type.

`Alloc::pointer` if that type exists, otherwise `value_type*`

Definition at line 156 of file bits/alloc_traits.h.

## propagate_on_container_copy_assignment

template<typename _Alloc>

using std::allocator_traits< _Alloc >::propagate_on_container_copy_assignment

How the allocator is propagated on copy assignment.

`Alloc::propagate_on_container_copy_assignment` if that type exists, otherwise `false_type`

Definition at line 236 of file bits/alloc_traits.h.

## propagate_on_container_move_assignment

template<typename _Alloc>

using std::allocator_traits< _Alloc >::propagate_on_container_move_assignment

How the allocator is propagated on move assignment.

`Alloc::propagate_on_container_move_assignment` if that type exists, otherwise `false_type`

Definition at line 244 of file bits/alloc_traits.h.

## propagate_on_container_swap

template<typename _Alloc>

using std::allocator_traits< _Alloc >::propagate_on_container_swap

How the allocator is propagated on swap.

`Alloc::propagate_on_container_swap` if that type exists, otherwise `false_type`

Definition at line 252 of file bits/alloc_traits.h.

## rebind_alloc

template<typename _Alloc>
template<typename _Tp>

using std::allocator_traits< _Alloc >::rebind_alloc

Definition at line 263 of file bits/alloc_traits.h.

## rebind_traits

template<typename _Alloc>
template<typename _Tp>

using std::allocator_traits< _Alloc >::rebind_traits

Definition at line 265 of file bits/alloc_traits.h.

## size_type

template<typename _Alloc>

using std::allocator_traits< _Alloc >::size_type

The allocator's size type.

`Alloc::size_type` if that type exists, otherwise make_unsigned<difference_type>::type

Definition at line 228 of file bits/alloc_traits.h.

## value_type

template<typename _Alloc>

typedef _Alloc::value_type std::allocator_traits< _Alloc >::value_type

The allocated type.

Definition at line 149 of file bits/alloc_traits.h.

## void_pointer

template<typename _Alloc>

using std::allocator_traits< _Alloc >::void_pointer

The allocator's void pointer type.

`Alloc::void_pointer` if that type exists, otherwise pointer_traits<pointer>::rebind<void>

Definition at line 204 of file bits/alloc_traits.h.

## Member Function Documentation

## allocate() [1/2]

template<typename _Alloc>

constexpr pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n )

inline static nodiscard constexpr

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.

Calls `a.allocate(n)`

Definition at line 330 of file bits/alloc_traits.h.

## allocate() [2/2]

template<typename _Alloc>

constexpr pointer std::allocator_traits< _Alloc >::allocate | ( | _Alloc & | __a,
|  | size_type | __n,
|  | const_void_pointer | __hint )

inline static nodiscard constexpr

Allocate memory.

Parameters

  __a | An allocator.
  __n | The number of objects to allocate space for.
  __hint | Aid to locality.

Returns
  Memory of suitable size and alignment for n objects of type `value_type`

Returns a.allocate(n, hint) if that expression is well-formed, otherwise returns `a.allocate(n)`

Definition at line 345 of file bits/alloc_traits.h.

## construct()

template<typename _Alloc>
template<typename _Tp, typename... _Args>

constexpr __enable_if_t< __can_construct< _Alloc, _Tp, _Args... > > std::allocator_traits< _Alloc >::construct | ( | _Alloc & | __a,
|  | _Tp * | __p,
|  | _Args &&... | __args )

inline static constexpr noexcept

Construct an object of type _Tp.

Parameters

  __a | An allocator.
  __p | Pointer to memory of suitable size and alignment for Tp
  __args | Constructor arguments.

Calls __a.construct(__p, std::forward<Args>(__args)...) if that expression is well-formed, otherwise uses placement-new to construct an object of type _Tp at location __p from the arguments __args...

Definition at line 374 of file bits/alloc_traits.h.

## deallocate()

template<typename _Alloc>

constexpr void std::allocator_traits< _Alloc >::deallocate | ( | _Alloc & | __a,
|  | pointer | __p,
|  | size_type | __n )

inline static constexpr

Deallocate memory.

Parameters

  __a | An allocator.
  __p | Pointer to the memory to deallocate.
  __n | The number of objects space was allocated for.

Calls a.deallocate(p, n)

Definition at line 357 of file bits/alloc_traits.h.

## destroy()

template<typename _Alloc>
template<typename _Tp>

constexpr void std::allocator_traits< _Alloc >::destroy | ( | _Alloc & | __a,
|  | _Tp * | __p )

inline static constexpr noexcept

Destroy an object of type _Tp.

Parameters

  __a | An allocator.
  __p | Pointer to the object to destroy

Calls `__a.destroy(__p)` if that expression is well-formed, otherwise calls `__p->~_Tp()`

Definition at line 393 of file bits/alloc_traits.h.

## max_size()

template<typename _Alloc>

constexpr size_type std::allocator_traits< _Alloc >::max_size | ( | const _Alloc & | __a | ) |

inline static constexpr noexcept

The maximum supported allocation size.

Parameters

  __a | An allocator.

Returns
  `__a.max_size()` or `numeric_limits<size_type>::max()`

Returns `__a.max_size()` if that expression is well-formed, otherwise returns `numeric_limits<size_type>::max()`

Definition at line 406 of file bits/alloc_traits.h.

## select_on_container_copy_construction()

template<typename _Alloc>

constexpr _Alloc std::allocator_traits< _Alloc >::select_on_container_copy_construction | ( | const _Alloc & | __rhs | ) |

inline static constexpr

Obtain an allocator to use when copying a container.

Parameters

  __rhs | An allocator.

Returns
  `__rhs.select_on_container_copy_construction()` or __rhs

Returns `__rhs.select_on_container_copy_construction()` if that expression is well-formed, otherwise returns __rhs

Definition at line 418 of file bits/alloc_traits.h.

The documentation for this struct was generated from the following file:

- bits/alloc_traits.h